


#include "stdafx.h"


#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <locale.h>
#include <string.h>

#include "windows.h"
#include "shlobj.h"

#include "os.h"
#include "fsx.h"
#include "bits.h"
#include "etc.h"
#include "font.h"
#include "comline.h"
#include "osreg.h"
#include "wimp.h"
#include "wos.h"
#include "oserr.h"


int verbose;


void terminate(char * format, ...)
{
 va_list   args;
 char      v[512];

 va_start(args, format);
 vsprintf(v, format, args);

 fprintf(stderr,"%s\r\n",v);

 va_end(args);

 exit(1);
}



/*****************************************************************************/



/*****************************************************************************/


static os_error * shellgetfontfolder(HWND hwnd,char * path,int size)
{
 os_error * err=NULL;
 LPITEMIDLIST pidlRoot = NULL;
 LPMALLOC pMalloc = NULL;

 SHGetMalloc(&pMalloc);

 SHGetSpecialFolderLocation(hwnd,CSIDL_FONTS,&pidlRoot);
 SHGetPathFromIDList(pidlRoot,path);

 if(pidlRoot)
 {
  pMalloc->Free(pidlRoot);
 }

 pMalloc->Release();

 return(err);
 USE(size);

}


static char fontpath[MAX_PATH];


static os_error * getfontpath(void)
{
 if(!fontpath[0])
 {
  CoInitialize(NULL);
  shellgetfontfolder(NULL,fontpath,sizeof(fontpath));
 }

 return(NULL);
}




static os_error * font_folder(void)
{
 getfontpath();

 printf("%s\r\n",fontpath);

 return(NULL);
}




/***************************************************************************/




static os_error * fxfn2(char * facename,char * fullfontname,font_enumdata * data)
{
 if(verbose)
 {
  printf("%s:%s\r\n",facename,fullfontname);
 }
 else
 {
  printf("%s\r\n",fullfontname);
 }

 return(NULL);

 USE(facename);
 USE(fullfontname);
 USE(data);
}





static os_error * fxfn(char * facename,char * fullfontname,font_enumdata * data)
{
 font_description fd;


// next line to skip FONTENUM_T1
// if(data->type==FONTENUM_TT || data->type==FONTENUM_OT)
 {
  strcpy(fd.name,facename);
  fd.charset=data->charset;

  font_enumerate(&fd,fxfn2);
 }

 return(NULL);

 USE(facename);
 USE(fullfontname);
 USE(data);
}


// CreateFont, then read, doesn't return actual font name

static os_error * font_list(void)
{
 os_error         * err;
 font_description   fd;

 err=NULL;

 fd.charset=ANSI_CHARSET;
// strcpy(fd.name,"");
 strcpy(fd.name,"Arial CE");
 font_enumerate(&fd,fxfn);

// fd.charset=SYMBOL_CHARSET;
// font_enumerate(&fd,fxfn);

	

 return(err);
}




/*******************************************************************************/


typedef int TTFIXED;
typedef unsigned short TTUSHORT;
typedef unsigned int   TTULONG;

typedef struct offsettablestr
{

 TTFIXED   version;
 TTUSHORT  numTables;
 TTUSHORT  searchRange;
 TTUSHORT  entrySelector;
 TTUSHORT  rangeshift;


} offsettablestr;


typedef struct tabledirstr
{
 TTULONG tag;      // 4 -byte identifier. 
 TTULONG checkSum; // CheckSum for this table. 
 TTULONG offset;   // Offset from beginning of TrueType font file. 
 TTULONG length;   // Length of this table. 
  
} tabledirstr;



typedef struct namerecordstr
{
 TTUSHORT id;     //Platform ID. 
 TTUSHORT encid;  //Platform-specific encoding ID. 
 TTUSHORT lanid;  //Language ID. 
 TTUSHORT nameid; //Name ID. 
 TTUSHORT len;    //String length (in bytes). 
 TTUSHORT offset; //String offset from start of storage area (in bytes). 

} namerecordstr;



typedef struct nametablestr
{
 TTUSHORT      format; //Format selector (=0). 
 TTUSHORT      nnames; //Number of NameRecords that follow n. 
 TTUSHORT      offset; //Offset to start of string storage (from start of table). 

 namerecordstr namerecord[1];

} nametablestr;





#define SWAPWORD(x) MAKEWORD(HIBYTE(x),LOBYTE(x))
#define SWAPLONG(x) MAKELONG(SWAPWORD(HIWORD(x)),SWAPWORD(LOWORD(x)))

#define     MAKETABLENAME(ch1, ch2, ch3, ch4) (\
    (((DWORD)(ch4)) << 24) | \
    (((DWORD)(ch3)) << 16) | \
    (((DWORD)(ch2)) << 8) | \
    ((DWORD)(ch1)) \
    )




static void  getwidestring(char * d,wchar_t * s,int len)
{
 int c;

 while(1)
 {
  c=*s++;
  c=SWAPWORD(c);
  *d++=(char)c;
  if(c==0) break;
  len-=2;
  if(len<=0)
  {
   *d++=0;
   break;
  }
 }
}




static os_error * ttfont(char * path,fxstat * f)
{
 os_error       * err;
 char           * data;
 offsettablestr * offsettable;
 tabledirstr    * tabledir;
 int              ntables;
 int              i;
 int              j;
 int              tag;
 nametablestr   * nametable;
 int              stringoffset;
 char           * strings;
 int              nnames;
 char             temp[1024];
 int              nameid;



 err=NULL;


	if(!fs_extensionis(path,"ttf"))
	{
  if(f->f.object==1)
  {
   if(verbose)	printf("Font file:%s\r\n",fs_leaf(path));

   data=(char*)malloc(f->f.length);
   if(data)
   {
    fs_loadblock(path,data);
 
    offsettable=(offsettablestr*)data;

    ntables=SWAPWORD(offsettable->numTables);
    tabledir=(tabledirstr*)(data+sizeof(offsettablestr));

    for(i=0;i<ntables;i++)
    {
     tag=tabledir->tag;

     if(tag==MAKETABLENAME('n','a','m','e'))
     {
      nametable=(nametablestr*)(data+SWAPLONG(tabledir->offset));

//     cprintf("tag %c %c %c %c",tag & 0xFF,(tag>>8)&0xFF,(tag>>16)&0xFF,(tag>>24)&0xFF);

      stringoffset=SWAPWORD(nametable->offset);
      strings=((char*)nametable)+stringoffset;

// The OpenType Font File

      nnames=SWAPWORD(nametable->nnames);

      for(j=0;j<nnames;j++)
      {
//      cprintf("platid %d encid %d lanid %d nameid %d",SWAPWORD(nametable->namerecord[j].id),
//      SWAPWORD(nametable->namerecord[j].encid),
//      SWAPWORD(nametable->namerecord[j].lanid),
//      SWAPWORD(nametable->namerecord[j].nameid));

       if(SWAPWORD(nametable->namerecord[j].id)==3)
       {
        temp[0]=0;

        nameid=SWAPWORD(nametable->namerecord[j].nameid);
        if(nameid==1)
        {
         getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
         printf("Familyname:%s\r\n",temp);
        }
        else
        if(nameid==2)
        {
         getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
         printf("Weight:%s\r\n",temp);
        }
        else
        if(nameid==4)
        {
         getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
         printf("Fullname:%s\r\n",temp);
        }
        else
        if(nameid==10 && verbose) // long info
        {
         getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
         printf("Info:%s\r\n",temp);
        }


//       cprintf("%s %d",temp,nameid);
       }


//       cprintf("offset %d",SWAPWORD(nametable->namerecord[j].offset));
      }
     }

     tabledir++;
    }

    free(data);

    printf("\r\n");
   }
  }
 }

 return(err);
}



static os_error * ttfontfullname(char * data,char * name)
{
 os_error       * err;

 offsettablestr * offsettable;
 tabledirstr    * tabledir;
 int              ntables;
 int              i;
 int              j;
 int              tag;
 nametablestr   * nametable;
 int              stringoffset;
 char           * strings;
 int              nnames;
 char             temp[1024];
 int              nameid;



 err=NULL;

 offsettable=(offsettablestr*)data;

 ntables=SWAPWORD(offsettable->numTables);
 tabledir=(tabledirstr*)(data+sizeof(offsettablestr));

 for(i=0;i<ntables;i++)
 {
  tag=tabledir->tag;

  if(tag==MAKETABLENAME('n','a','m','e'))
  {
   nametable=(nametablestr*)(data+SWAPLONG(tabledir->offset));

//     cprintf("tag %c %c %c %c",tag & 0xFF,(tag>>8)&0xFF,(tag>>16)&0xFF,(tag>>24)&0xFF);

   stringoffset=SWAPWORD(nametable->offset);
   strings=((char*)nametable)+stringoffset;

// The OpenType Font File

   nnames=SWAPWORD(nametable->nnames);

   for(j=0;j<nnames;j++)
   {
//      cprintf("platid %d encid %d lanid %d nameid %d",SWAPWORD(nametable->namerecord[j].id),
//      SWAPWORD(nametable->namerecord[j].encid),
//      SWAPWORD(nametable->namerecord[j].lanid),
//      SWAPWORD(nametable->namerecord[j].nameid));

    if(SWAPWORD(nametable->namerecord[j].id)==3)
    {
     temp[0]=0;

     nameid=SWAPWORD(nametable->namerecord[j].nameid);
     if(nameid==1)
     {
//      getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
//      printf("Familyname:%s\r\n",temp);
     }
     else
     if(nameid==2)
     {
//      getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
//      printf("Weight:%s\r\n",temp);
     }
     else
     if(nameid==4)
     {
      getwidestring(name,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
//       printf("Fullname:%s\r\n",temp);
     }
     else
     if(nameid==10 && verbose) // long info
     {
//         getwidestring(temp,(wchar_t*)(strings+SWAPWORD(nametable->namerecord[j].offset)),SWAPWORD(nametable->namerecord[j].len));
//         printf("Info:%s\r\n",temp);
     }


//       cprintf("%s %d",temp,nameid);
    }


//       cprintf("offset %d",SWAPWORD(nametable->namerecord[j].offset));
   }
  }

  tabledir++;
 }

 return(err);
}


/*******************************************************************************/

#ifdef NEVER

static os_error * font_exists(char * familyname,char * fullname,int * exists)
{
 os_error         * err;
 font_description   fd;

 err=NULL;

// cprintf("exists %s",familyname);

 xfullname=fullname;
 fxfncalled=0;
 fd.charset=ANSI_CHARSET;
 strcpy(fd.name,familyname);
 font_enumerate(&fd,fxfn);

 if(!fxfncalled)
 {
  fd.charset=SYMBOL_CHARSET;
  font_enumerate(&fd,fxfn);
 }

 *exists=fxfncalled;

 return(err);
}


#endif

/*****************************************************************************/


static char * fontreg(void)
{
 if(ISW9X) return("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Fonts");
 else      return("HKLM\\Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts");
}


static os_error * font_regloc(void)
{
 printf("%s\r\n",fontreg());
 return(NULL);
}


static os_error * font_reglist(void)
{
 os_error * err;
 int        index;
 int        type;
 int        eof;
 oskeyh     key;
 int        size;
 char       string[256];
 int        dsize;
 char       data[256];

 index=0;

 
 err=regopenkey(fontreg(),&key,'r');
 if(!err)
 {
  while(1)
  {
   size=sizeof(string);
   dsize=sizeof(data);

   err=regenumvalue(key,string,&size,&type,data,&dsize,&eof,&index);

   if(err) break;
   if(eof) break;

   if(verbose)
   {
    printf("%-56s%s\r\n",string,data);
   }
   else
   {
    printf("%s\r\n",string);
   }
  }

  err=regclosekey(&key,err);
 }

 return(err);
}




static os_error * installfontpermanently(char * name,fxstat * f)
{
 os_error * err;
 char       temp[MAX_PATH];
 char     * data;
 char       fullname[256];

 err=NULL;

	if(!fs_extensionis(name,"ttf"))
	{
  if(verbose)	printf("copy %s\r\n",f->name);

  getfontpath();

  fs_join(temp,NITEM(temp),fontpath,f->name);

  data=(char*)malloc(f->f.length);
  if(data)
  {
   err=fs_loadblock(name,data);
   if(!err)
   {
    ttfontfullname(data,fullname);

    err=fs_saveblock(temp,0,data,f->f.length);

    if(!err)
    {
     fs_stamp(temp,&f->f);

     sprintf(temp,"%s\\%s (TrueType)",fontreg(),fullname);
     err=regwritestr(temp,f->name);

     if(!err)
     {
      fs_join(temp,NITEM(temp),fontpath,f->name);
//      fs_newextension(temp,"fot");

//      CreateScalableFontResource(0,temp,f->name,fontpath);
      
//      printf("create scale %s\r\n",temp);

//      fs_join(temp,fontpath,f->name);
      err=XAddFontResource(temp);
      SendMessage(HWND_BROADCAST,WM_FONTCHANGE,(WPARAM)0,(LPARAM)0);
     }
    }
   }
   free(data);
  }
 }

 return(err);
}




static os_error * removefontpermanently(char * name,fxstat * f)
{
 os_error * err;
 char       filename[MAX_PATH];
 int        object;
 fstat      fx;
 char       fullname[256];
 char     * data;

 err=NULL;

	if(!fs_extensionis(name,"ttf"))
	{
  if(verbose)	printf("delete %s\r\n",f->name);

  getfontpath();

  fs_join(filename,NITEM(filename),fontpath,f->name);

  fs_stat(filename,&fx);

  data=(char*)malloc(fx.length);
  if(data)
  {
   fs_loadblock(filename,data);

   ttfontfullname(data,fullname);

   err=XRemoveFontResource(filename);
  
   if(!err)
   {
    err=fs_exists(filename,&object);
    if(!err)
    {
     if(object) err=fs_delete(filename);
    }
   }

   if(!err)
   {
    sprintf(filename,"%s\\%s (TrueType)",fontreg(),fullname);
    err=regdeletekey(filename);
   }

   free(data);
  }
  SendMessage(HWND_BROADCAST,WM_FONTCHANGE,(WPARAM)0,(LPARAM)0);
 }

 return(err);
}





/*******************************************************************************/



os_error * installfont(char * name,fxstat * f)
{
 os_error * err=NULL;

	if(!fs_extensionis(name,"ttf"))
	{
  if(verbose)	printf("install %s\r\n",name);

 	err=XAddFontResource(name);
  SendMessage(HWND_BROADCAST,WM_FONTCHANGE,(WPARAM)0,(LPARAM)0);
	}

	return(err);

 USE(f);
}


os_error * removefont(char * name,fxstat * f)
{
 os_error * err=NULL;

	if(!fs_extensionis(name,"ttf"))
	{
  if(verbose)	printf("remove %s\r\n",name);

  err=XRemoveFontResource(name);
  SendMessage(HWND_BROADCAST,WM_FONTCHANGE,(WPARAM)0,(LPARAM)0);
	}

	return(err);

 USE(f);
}



/****************************************************************************/


static os_error * font_help(void)
{
 fprintf(stderr,"fontq -a <font file path> copy font to fonts folder and permanently install\r\n");
 fprintf(stderr,"fontq -d <font file path> delete font from fonts folder and permanently uninstall\r\n");
	fprintf(stderr,"fontq -f show fonts folder location\r\n");
	fprintf(stderr,"fontq -g list font information from registry\r\n");
	fprintf(stderr,"fontq -h help\r\n");
 fprintf(stderr,"fontq -i <font file path> temporarily install font\r\n");
 fprintf(stderr,"fontq -k show font registry keys\r\n");
 fprintf(stderr,"fontq -l list the fonts applications know about\r\n");
 fprintf(stderr,"fontq -r <font file path> temporarily uninstall font\r\n");
	fprintf(stderr,"fontq -t <font file path> show information in font file\r\n");
	fprintf(stderr,"fontq -v verbose, shows extra information\r\n");
	fprintf(stderr,"version 1.00 (c) David Pilling Ltd. 2004 www.davidpilling.net\r\n");

 return(NULL);
}







/****************************************************************************/




int main(int argc, char* argv[])
{
 os_error * err;
	int        c;

 err=NULL;

 getoptboot();

 if(argc==1) font_help();
 else
 {
  while((c=getopt(argc,argv,"a:d:fghi:kr:lvt:"))!=EOF)
  {
   switch(c)
   {    
    case 'a':
         				err=glob(getoptarg,NULL,installfontpermanently);
             break;

    case 'd':
         				err=glob(getoptarg,NULL,removefontpermanently);
             break;

    case 'f':
             err=font_folder();
             break;

    case 'g':
             err=font_reglist();
             break;

    case 'h':
				case	'?':
             err=font_help();
             break;

    case 'i':
         				err=glob(getoptarg,NULL,installfont);
													break;

    case 'k':
             err=font_regloc();
             break;

				case	'r':
         				err=glob(getoptarg,NULL,removefont);
													break;

				case	'l':
 		          err=font_list();
													break;

    case 't':
             err=glob(getoptarg,NULL,ttfont);
             break;

				case	'v':
													verbose=1;
													break;
  	}
	 }
 }

 if(err)
 {
  fprintf(stderr,"%s\r\n",err->errmess);
  return(1);
 }
 else
 {
  return 0;
 }
}
